# require "set"
# require "faraday"
# require "sawyer"
#
# require "nearmiss-ruby/response"
# require "nearmiss-ruby/error"
# require "nearmiss-ruby/raise_error"
# require "nearmiss-ruby/version"
require "tiny_tds"
require "toolhound-ruby/version"

require "toolhound-ruby/util"

require "toolhound-ruby/core_ext/string"
require "toolhound-ruby/configurable"
# require "nearmiss-ruby/response"
require "toolhound-ruby/client"
require "toolhound-ruby/default"
require "toolhound-ruby/base"

require "toolhound-ruby/job"
require "toolhound-ruby/project"
require "toolhound-ruby/inventory"
require "toolhound-ruby/inventory_item"
require "toolhound-ruby/rental"
require "toolhound-ruby/rental_item"
require "toolhound-ruby/rental_charge"
require "toolhound-ruby/transaction"

require "toolhound-ruby/purchase_receipt"

require "toolhound-ruby/vendor"
require "toolhound-ruby/manufacturer"
require "toolhound-ruby/purchase_order"


# require "nearmiss-ruby/util"

module Toolhound

  class << self

    include Toolhound::Configurable
    # include Nearmiss::Util

    # API client based on configured options {Configurable}
    #
    # @return [Toolhound::Client] API wrapper
    def client
      @client = Toolhound::Client.new(options) unless defined?(@client) && @client.same_options?(options)
      @client
    end

    # @private
    def respond_to_missing?(method_name, include_private=false)
      client.respond_to?(method_name, include_private)
    end

  private

    def method_missing(method_name, *args, &block)
      return super unless client.respond_to?(method_name)
      client.send(method_name, *args, &block)
    end


  end
end
Toolhound.setup
