module Toolhound
  module Configurable

    # attr_accessor :auto_paginate, :per_page
    attr_writer :dataserver, :port, :username, :password, :timeout

    # Define static methods
    class << self

      def keys
        @keys ||= [
          :dataserver,
          :port,
          :username,
          :password,
          :timeout
        ]
      end
    end

    # Set configuration options using a block
    def configure
      yield self
    end

    # Reset configuration options to default values
    def reset!
      Toolhound::Configurable.keys.each do |key|
        instance_variable_set(:"@#{key}", Toolhound::Default.options[key])
      end
      self
    end
    alias setup reset!

    # def api_endpoint
    #   File.join(@api_endpoint, "")
    # end

    def options
      Hash[Toolhound::Configurable.keys.map{|key| [key, instance_variable_get(:"@#{key}")]}]
    end

  private



  end
end
