# require "bim360/version" unless defined?(Nearmiss::VERSION)
# require 'bim360/response/raise_error'

module Toolhound


  # Default configuration options for {Client}
  module Default

    # Default User Agent header string

    PORT          = 1433.freeze

    class << self

      # Configuration options
      # @return [Hash]
      def options
        Hash[Toolhound::Configurable.keys.map{|key| [key, send(key)]}]
      end



      def config
        @config ||= {}
      end

      # Default API endpoint from ENV or {API_ENDPOINT}
      # @return [String]
      def dataserver
        ENV['TOOLHOUND_DATASERVER'] || config['dataserver']
      end

      def port
        ENV['TOOLHOUND_PORT'] || config['port'] || PORT
      end

      # Default BIM360-Field username for Basic Auth from ENV
      # @return [String]
      def username
        ENV['TOOLHOUND_USERNAME'] || config['username']
        # ENV['NEARMISS_EMAIL'] || config['email']
      end

      def timeout
        config['timeout'] || 10
      end
      # Default BIM360-Field password for Basic Auth from ENV
      # @return [String]
      def password
        ENV['TOOLHOUND_PASSWORD'] || config['password']
      end




    end

  end
end
